#===========================================================================================================================================
#   This is the Python script used to generate txt files of planetary velocities and speeds at a given year (start of Jan 1st)
#   In order to generate the desired file, change the "year" variable to the desired year and change the filepath (lines 11 & 31)
#===========================================================================================================================================

#importing the required apis
from astropy.time import Time
from astroquery.jplhorizons import Horizons

#the year to get positions for
year = 2020

#conversion to date for query
datestring = str(year) + "-01-01"
date = Time(datestring).jd

#for each of the 8 planets:
for i, bodyid in enumerate([1,2,3,4,5,6,7,8]):
    #api call to jpl horizons for planetary data at specified time, in vector form
    body = Horizons(id=bodyid, location="@sun", epochs=date, id_type='id').vectors()

    #getting the required data from the returned table
    xPos = body["x"].data[0]
    yPos = body["y"].data[0]
    zPos = body["z"].data[0]
    xVel = body["vx"].data[0]
    yVel = body["vy"].data[0]
    zVel = body["vz"].data[0]

    #writing the data to a txt file
    filepath = "E:/RealPositions/" + str(year) + "positions.txt"
    f = open(filepath, "a")
    stringToWrite = ",".join([str(xPos),str(yPos),str(zPos),str(xVel),str(yVel),str(zVel)]) + ","
    f.write(stringToWrite)
    f.close()