#pragma once

USTRUCT(NoExport)
struct FVectorDouble {
	//properties
	double X, Y, Z;

	//multiply with other vector
	FVectorDouble operator*(FVectorDouble vec) {
		return FVectorDouble{
			X * vec.X,
			Y * vec.Y,
			Z * vec.Z
		};
	}

	//multiply with double
	FVectorDouble operator*(double num) {
		return FVectorDouble{
			X * num,
			Y * num,
			Z * num
		};
	}

	//divide by other vector
	FVectorDouble operator/(FVectorDouble vec) {
		return FVectorDouble{
			X / vec.X,
			Y / vec.Y,
			Z / vec.Z
		};
	}

	//didivde by double
	FVectorDouble operator/(double num) {
		return FVectorDouble{
			X / num,
			Y / num,
			Z / num
		};
	}

	//add with other vector
	FVectorDouble operator+(FVectorDouble vec) {
		return FVectorDouble{
			X + vec.X,
			Y + vec.Y,
			Z + vec.Z
		};
	}

	//minus other vector
	FVectorDouble operator-(FVectorDouble vec) {
		return FVectorDouble{
			X - vec.X,
			Y - vec.Y,
			Z - vec.Z
		};
	}

	//increase by other vector
	FVectorDouble operator+=(const FVectorDouble& vec) {
//	FVectorDouble operator+=(FVectorDouble vec) {
		
		X += vec.X;
		Y += vec.Y;
		Z += vec.Z;
		return FVectorDouble{ X, Y, Z };
	}
};

//struct for gravitational bodies
USTRUCT(NoExport)
struct FBody {
	FVectorDouble Pos;
	FVectorDouble Vel;
	double Mass;
	double GM;
};

//struct for recording the simulation
USTRUCT(NoExport)
struct FSnapshot {
	TArray<FVectorDouble> positions;
	double time;
};